#ifndef RiffHeadHH
#define RiffHeadHH
#include <cstdio>
#include <string>
using namespace std;

#include "autoptr"
#include "stat.h"

class RiffHead: public ptrable
{
public:
    virtual ~RiffHead();
    virtual string Read(FILE *fp, unsigned bytes) = 0;
};

extern void FindSomething(FILE *fp);
extern void RegisterFormat(const char *code, autoptr<RiffHead> instance);
extern unsigned ReadDW(FILE *fp);
extern unsigned ReadW(FILE *fp);
extern bool quiet;

extern void RegisterFieldDouble(const char *name, const char *description);
extern bool IsDefined(const string& name);
extern double GetFieldDouble(const string& name);

extern void PatchDW(FILE *fp, SizeType pos, unsigned value);
extern void PatchW(FILE *fp, SizeType pos, unsigned value);

#endif
